#ifndef VED_GENERAL_WRAPPER_HEADER_H
#define VED_GENERAL_WRAPPER_HEADER_H


#include "ara/log/logging.h"
#include "dpc_ved/executable.h"
#include "sub/SubWrapperHelper.h"
#include "pub/PubWrapperHelper.h"
#include "ara/exec/execution_client.h"
#include "VED_PubDataWrapper.h"
#include "VED_SubDataWrapper.h"

using namespace jac::ap::vedservice::skeleton;
using namespace jac::ap::canservice::proxy;

//PubWrappers
GENERATE_PUB_WRAPPER(VED2DPC_Provide, VED2DPC_PubDataWrapper, VEDServiceSkeleton, dpc::VED4DPC, VED4DPCEvent);
GENERATE_PUB_WRAPPER(VED2FusionEgoMotion_Provide, VED2FusionEgoMotion_PubDataWrapper, VEDServiceSkeleton, dpc::VED4FusionEgoMotion, VED2FusionEgoMotionEvent);
//SubWrappers
GENERATE_SUB_WRAPPER(CAN2VED_Required, CAN2VED_SubDataWrapper, CANServiceProxy, CAN2SWC, CAN2SWCEvent, "3", 10);

class GeneralWrapper{
public:
    VED2DPC_Provide _VED2DPC_Provide;
    VED2FusionEgoMotion_Provide _VED2FusionEgoMotion_Provide;
    CAN2VED_Required _CAN2VED_Required;
    GeneralWrapper(ara::log::Logger& mainLog);
    ~GeneralWrapper();
};


#endif //VED_GENERAL_WRAPPER_HEADER_H
